<?php

    header('Content-type: text/plain');
    // https://www.indiabeeps.com/allprojects/viewssmc/ssmcinput.php?jsonData=nil&attendance=hello%20boy
    
	include_once ('includes/variables.php'); 
	date_default_timezone_set('Asia/Kolkata');
	
	
	
    
   function deleteoldrecordsBx($conn, string $whichShop)
   {
       delete_records_correct($conn, $whichShop);
       return;
       
       // $branch = strtolower($whichShop);
       // $url = 'deletebx/delete-all-records-'.$branch.'.php';
       // include($url);   // just runs
       
       // If interested, please refere to the code in:
       // viewssmc/deletebx/delete-all-records-b5.php or
       // viewssmc/ssmcdeleterecords.php?branch=B5
   }
   
   
   function delete_records_correct($conn, string $whichShop)
   {
        echo "<br>";
        
        //=================================================================
        $whichShop1 = $whichShop.'/';    //example)  'B5/'
        $whichShop2 = mysqli_real_escape_string($conn, $whichShop1);
        // echo "<br>whichShop2: " . $whichShop2;
        
        $sql = " DELETE FROM ssmc where uid LIKE '$whichShop2%'";
        // echo "<br>sql: " . $sql;
        
        if (mysqli_query($conn, $sql)) {
            echo "<br>".$whichShop. ": ssmc:Records deleted successfully.";
        } else {
            echo "<br>".$whichShop. ": ssmc:Error deleting record: " . mysqli_error($conn);
        }
        
        //=================================================================
        $sql = " DELETE FROM ssmcnow where uid LIKE '$whichShop2%'";

        if (mysqli_query($conn, $sql)) {
            echo "<br>".$whichShop. ": ssmcnow:Records deleted successfully.";
        } else {
            echo "<br>".$whichShop. ": ssmcnow:Error deleting record: " . mysqli_error($conn);
        }
        
   }
   
   function wh_log($log_msg)
    {
        $log_filename = "log";
        if (!file_exists($log_filename)) 
        {
            // create directory/folder uploads.
            mkdir($log_filename, 0777, true);
        }
        $log_file_data = $log_filename.'/log_' . date('d-M-Y') . '.log';
        // if you don't add `FILE_APPEND`, the file will be erased each time you add a log
        file_put_contents($log_file_data, $log_msg . "\n", FILE_APPEND);
    } 
    
    
        
    // returns true if $needle is a substring of $haystack
    function str_contains2($haystack, $needle)
    {
        return strpos($haystack, $needle) !== false;
    }
    

    $attendanceData = $_REQUEST['attendance'];
	echo "AttendanceData: " . $attendanceData;
	
	if($attendanceData != ""){
        // Example 1
        // $attendanceData  = "piece1 piece2 piece3 piece4 piece5 piece6";  1666793820
        $aryAd = explode(" ", $attendanceData);
        // $date1 = $aryAd[0]; 
        // E3 has some work here
        $epoch = trim($aryAd[0]);
        // $epoch =  1666538749;  //  23/10/2022
        $epochInt = (int)$epoch;
        echo ", epochInt: ".$epochInt." ";
          
        $branch = "B0";
        if (str_contains($attendanceData, 'B5')) { 
            echo ", Branch: B5 ";
            $branch = "B5";
        } 
        else if (str_contains($attendanceData, 'B8')) { 
            echo ", Branch: B8 ";
            $branch = "B8";
        } 
        else if (str_contains($attendanceData, 'B9')) { 
            echo ", Branch: B9 ";
            $branch = "B9";
        }
        else if (str_contains($attendanceData, 'B11')) { 
            echo ", Branch: B11 ";
            $branch = "B11";
        }
        
        if ($branch != "B0"){
            if(is_int($epochInt) == 1){
                // Attendance file missing
                // $phpdate = (date("Y-m-d h:i:sa", $epochInt));
                $phpdate = (date("Y-m-d", $epochInt));
                $branchdate = $branch.$phpdate;
                $sqlQuery = "INSERT INTO ssmc_attendance (uid,detail,date,branchdate) VALUES ('$branch', '$attendanceData', '$phpdate','$branchdate')";
                mysqli_query($conn, $sqlQuery);
            }
        }
	}
    
    
    $jsonDataBeforeDecode = $_REQUEST['jsonData'];
    
    if(empty($jsonDataBeforeDecode)){
        echo "No jsonData data from url request from Form encoded data.\n";
        
        // Check if the request is a POST request
        if ($_SERVER["REQUEST_METHOD"] === "POST") {
            // Get the JSON data from the request body
            $jsonDataBeforeDecode = file_get_contents("php://input");
            
            if(empty($jsonDataBeforeDecode)){
                echo "No jsonDataBeforeDecode even from Json file, so skipping Sales data upload.";
            }
        }
    }
    
    if(empty($jsonDataBeforeDecode)){
        echo "No jsonDataBeforeDecode, so skipping Sales data upload.";
    }
    
    
	// echo "\njsonDataBeforeDecode: " . $jsonDataBeforeDecode;
	// return;
	// exit;
	
    $jsonDataBeforeDecode = preg_replace("/\r|\n/", "", $jsonDataBeforeDecode);
	$jsonData = json_decode($jsonDataBeforeDecode, true);
	$count = count((array)$jsonData);
	$date = date('Y/m/d H:i:s');
	
     wh_log("\nTime: " . $date); 
     wh_log("JsonDataRowsCount: " . $count); 
     // wh_log("jsonData: " . $jsonData); 
	
	
	for($i=0; $i<$count; $i++){
	    $uid = $jsonData[$i]['uid'];
        $detail = $jsonData[$i]['detail'];
        $product = $jsonData[$i]['product'];
        $amount = $jsonData[$i]['amount'];
        
        $epoch = $jsonData[$i]['date'];
        $epochInt = (int)$epoch;
        $phpdate = (date("Y-m-d h:i:sa", $epochInt));
        
        // Error reporting works good.
        // $all = $uid.', '.$detail.', '.$product.', '.$amount.', '.$phpdate.'<br>';
        // wh_log("$jsonData[$i]:". $all); 
        
        if($i == 0) {
            $spos = strpos($uid, "/");
            $shop = substr($uid, 0, $spos);
            // $shop = substr($uid, 0, 2);
            deleteoldrecordsBx($conn, $shop);
        }
        
        if ($detail == "^^^")continue;
        
        
        if($uid != ""){
            $sqlQuery = "INSERT INTO ssmc (uid,detail,product,amount,date) VALUES ('$uid', '$detail', '$product', '$amount', '$phpdate')";
            mysqli_query($conn, $sqlQuery);
        }
        
        if($uid != ""){
            $sqlQuery = "INSERT INTO ssmcnow (uid,detail,product,amount,date) VALUES ('$uid', '$detail', '$product', '$amount', '$phpdate')";
            mysqli_query($conn, $sqlQuery);
        }
	}
	
	echo "\nSuccess";
 
 ?>
