<?php

    header('Content-type: text/plain');
	date_default_timezone_set('Asia/Kolkata');
	
    // This:  https://www.indiabeeps.com/allprojects/viewssmc/ssmcinput-as-json.php (send json as file)
    // calls: https://www.indiabeeps.com/allprojects/viewssmc/ssmcinput.php?jsonData=nil&attendance=hello%20boy
    

    function wh_log($log_msg)
    {
        $log_filename = "log";
        if (!file_exists($log_filename)) 
        {
            // create directory/folder uploads.
            mkdir($log_filename, 0777, true);
        }
        $log_file_data = $log_filename.'/log_' . date('d-M-Y') . '.log';
        // if you don't add `FILE_APPEND`, the file will be erased each time you add a log
        file_put_contents($log_file_data, $log_msg . "\n", FILE_APPEND);
    } 
    
    

    // Check if the request is a POST request
    if ($_SERVER["REQUEST_METHOD"] !== "POST") {
	    echo "\nIt is not Post Method call, so exiting...";
        return;
        exit;
    }
    
     wh_log("\nWelcome to: ssmcinput-as-json.php"); 
    
    // Replace 'your_api_url' with the actual API URL you want to send the file contents to.
    $api_url = 'https://www.indiabeeps.com/allprojects/viewssmc/ssmcinput.php';
    
    // Replace 'your_file_path' with the path to the file you want to send.
    $file_path = "php://input";
        
    
    // Get the JSON data from the request body
    // Read the file contents.
    $file_contents = file_get_contents($file_path);
    
    // Encode the file contents as a URL parameter.
    $file_contents_encoded = urlencode($file_contents);
    
    // Create the complete URL with the parameter.
    $complete_url = $api_url . '?jsonData=' . $file_contents_encoded;
    
    // Initiate a cURL session to send the request to the API.
    $curl = curl_init();
    
    // Set the cURL options.
    curl_setopt($curl, CURLOPT_URL, $complete_url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    
    // Execute the cURL session and store the response in a variable.
    $response = curl_exec($curl);
    
    
     wh_log("\ncurl_exec Response: " . $response); 
    
    // Check for cURL errors.
    if (curl_errno($curl)) {
        $error_message = curl_error($curl);
        // Handle the error accordingly (e.g., log it or display an error message).
    }
    
    // Close the cURL session.
    curl_close($curl);
    
    // Process the API response as needed.
    // $response contains the response from the API.

?>
